/* Copyright (c) 2006-2011, Peter Speck / Vitality. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Vitality nor the names of its contributors may be
 *       used to endorse or promote products derived from this software without
 *       specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PETER SPECK / VITALITY AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL PETER SPECK / VITALITY AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package dk.vitality.lib.foundation.xml.xpath;


public final class PathCompilerToken
{
	public static final int UNKNOWN = 0;
	public static final int END = 1;
	public static final int PATH_SEPARATOR = 2;
	public static final int DEEP_CHILDS = 3;
	public static final int CURRENT_NODE = 4;
	public static final int NAMED_CHILD = 5;
	public static final int ALL_CHILDS = 6;
	public static final int PARENT_ELEMENT = 7;
	public static final int ATTRIBUTE = 8;
	public static final int TEST_START = 9;
	public static final int TEST_END = 10;
	public static final int STRING = 11;
	public static final int AND = 12;
	public static final int NOT = 13;
	public static final int EQUALS = 14;
	public static final int NOT_EQUALS = 15;
	public static final int INTEGER = 16;
	public static final int PARAN_START = 17;
	public static final int PARAN_END = 18;

	int type = UNKNOWN;
	String txt;
	int integerValue;

	public final void reset()
	{
		type = UNKNOWN;
		txt = null;
		integerValue = -42;
	}

	/*
 perl -pe 's|^[\sa-z]+([A-Z_]+).*|case $1: return "$1";|' z
 */
	public String getName()
	{
		switch (type) {
			case UNKNOWN:
				return "UNKNOWN";
			case END:
				return "END";
			case PATH_SEPARATOR:
				return "PATH_SEPARATOR";
			case DEEP_CHILDS:
				return "DEEP_CHILDS";
			case CURRENT_NODE:
				return "CURRENT_NODE";
			case NAMED_CHILD:
				return "NAMED_CHILD";
			case ALL_CHILDS:
				return "ALL_CHILDS";
			case PARENT_ELEMENT:
				return "PARENT_ELEMENT";
			case ATTRIBUTE:
				return "ATTRIBUTE";
			case TEST_START:
				return "TEST_START";
			case TEST_END:
				return "TEST_END";
			case STRING:
				return "STRING";
			case AND:
				return "AND";
			case NOT:
				return "NOT";
			case EQUALS:
				return "EQUALS";
			case NOT_EQUALS:
				return "NOT_EQUALS";
			case INTEGER:
				return "INTEGER";
			case PARAN_START:
				return "PARAN_START";
			case PARAN_END:
				return "PARAN_END";
			default:
				return "BAD-VALUE";
		}
	}
}

// END OF FILE
