/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>

@class Prefs;

@interface NamedEnum : NSObject
{
}

- (instancetype)initWithSemicolonList:(NSString*)encoded;

- (NSString*)nameFromIndex:(NSInteger)idx;

- (NSInteger)indexFromXPath:(NSString*)xpath
				  withPrefs:(Prefs*)prefs;
- (NSInteger)indexFromXPath:(NSString*)xpath
				  withPrefs:(Prefs*)prefs
				withDefault:(NSString*)defaultValue;

- (NSInteger)indexFromXPath:(NSString*)xpath
				   withRoot:(NSXMLElement*)rootE
				withDefault:(NSString*)defaultValue;

- (void)selectDefaultItemInPop:(NSPopUpButton*)pop;

- (void)updatePopButton:(NSPopUpButton*)pop
				toValue:(NSString*)value;

- (void)updatePopButton:(NSPopUpButton*)pop
			  fromXPath:(NSString*)xpath
			   withRoot:(NSXMLElement*)rootE;

- (void)updatePopButton:(NSPopUpButton*)pop
			  fromXPath:(NSString*)xpath
			   withRoot:(NSXMLElement*)rootE
			withDefault:(NSString*)defaultValue;

- (NSString*)selectedPopValue:(NSPopUpButton*)pop;
@end

