/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.admin.filter;

import org.glimmerblocker.proxy.admin.AbstractAdminXmlHandler;
import org.glimmerblocker.proxy.proxyRequest.ProxyRequestHandler;
import org.jetbrains.annotations.NotNull;
import dk.vitality.lib.foundation.xml.xpath.XmlArgs;

public class AdminFilterSubGet extends AbstractAdminXmlHandler
{
	public AdminFilterSubGet(@NotNull ProxyRequestHandler req) throws Exception
	{
		super(req);
	}

	protected void processAdminXml() throws Exception
	{
		int filterId = urlParams.reqInt("filter-id");
		XmlArgs xa = globals.filterSubscriptions.getOptFilterContainerXA(filterId);
		if (xa == null)
			throw new Exception("Filter data not downloaded.");
		rootE.appendChild(doc.importNode(xa.getContextElement(), true));
	}
}