/* Copyright (C) 2009-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.globals.network.dns;

import org.glimmerblocker.proxy.globals.log.Logger;
import org.jetbrains.annotations.NotNull;
import dk.vitality.lib.foundation.ref.FatRef;
import dk.vitality.lib.connectionCache.ConnectionCache;
import dk.vitality.lib.connectionCache.ConnectionInfo;

public class DnsResolverCache extends ConnectionCache<DnsResolverConnection, DnsResolverConnection>
{
	@NotNull public final DnsResolverConfig config;
	@NotNull private final Logger logger;
	@NotNull private FatRef<Boolean> debugNetworkConfig;

	public DnsResolverCache(@NotNull DnsResolverConfig config,
	                        @NotNull Logger logger,
	                        @NotNull FatRef<Boolean> debugNetworkConfig)
	{
		super(config.javascriptText, Integer.MAX_VALUE);
		this.config = config;
		this.logger = logger;
		this.debugNetworkConfig = debugNetworkConfig;
		this.shouldLogCreationAndDestroy = false;
	}

	@NotNull
	protected ConnectionInfo<DnsResolverConnection> createNewConnection() throws Exception
	{
		return new DnsResolverConnection(config, logger, debugNetworkConfig);
	}
}
