/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.http.client.cache;

import org.glimmerblocker.proxy.globals.log.Logger;
import org.glimmerblocker.proxy.globals.network.dns.DnsResolver;
import org.jetbrains.annotations.Nullable;
import dk.vitality.lib.foundation.ref.FatRef;

public class HttpWorksheet implements Logger
{
	public static void main(String[] args)
	{
		try {
			new HttpWorksheet();
			Thread.sleep(60 * 1000);
			System.exit(0);
		}
		catch (Exception ex) {
			System.err.println("Got exception: " + ex.getMessage());
			ex.printStackTrace();
		}
	}

	HttpWorksheet() throws Exception
	{
		logger = new Logger()
		{
			public void ln(@Nullable String s)
			{
				System.err.println("LOG: " + s);
			}
		};
		//ScheduledThreadPoolExecutor execService = new ScheduledThreadPoolExecutor(2);
		FatRef<Boolean> ref = new FatRef<>(true);
		DnsResolver resolver = new DnsResolver(logger, ref);
		cache = new HttpClientCache(resolver, logger, ref);
		for (int i = 0; i < 10; i++) {
			GET("http://127.0.0.1:80/z.txt");
			Thread.sleep(5000);
		}
		//GET("http://www.ruc.dk/");
		//GET("http://www.ruc.dk/ruc/");
		//GET("http://www.dancenter.dk/pubweb/vishus4e/screen.css/tmd5=ddd3c8416e7ffc057a1bb9d68ffa16ae/screen.css");
		//GET("http://forums.appleinsider.com/showthread.php?s=&threadid=89571");
	}

	HttpClientCache cache;
	Logger logger;

	@SuppressWarnings({"UnusedDeclaration"})
	private void GET(String u) throws Exception
	{
		/*
		final URL url = new URL(u);
		int port = url.getPort();
		if (port <= 0)
			port = 80;
		HttpRunnable r = new HttpRunnable()
		{
			public void run(HttpClientConnection conn) throws Exception
			{
				HeadersBuilder hb = HeadersBuilder.makeEmpty();
				hb.add("User-Agent", "Nobody/1.0");
				hb.add("Accept-Encoding", "gzip");
				//hb.add("If-Modified-Since", "Thu, 31 Jul 2008 09:30:32 GMT");
				//
				RequestBody rb = new RequestBody(null, -1);
				HttpTransaction t = conn.makeTransaction(new RequestData("GET", url, hb.toHeaders(), rb));
				ln("Sends request");
				t.sendRequest();
				ln("Receives response");
				HttpResponseInfo rhi = t.getResponseHeaderInfo();
				BodyCollector bc = new BodyCollector(rhi);
				bc.readBody(t.getBodyStream());
				ResultData rd = bc.getResultData();
				ln("--------------- Result");
				ln("  status = " + rd.headers.status + " " + rd.headers.statusMessage);
				for (String name : rd.headers.headerMap.keySet()) {
					for (String value : rd.headers.headerMap.get(name))
						ln("   " + name + " = " + value);
				}
				ln("--------");
				byte[] b = rd.getContent();
				if (b == null) {
					ln("  No response body.");
				} else if (b.length == 0) {
					ln("  Empty response body.");
				} else {
					ln("  Content-length: " + b.length);
					ln("{{{{{{{{{{{{{\n" + rd.getContentAsText(logger, false) + "}}}}}}}}}}}}}");
				}
			}
		};
		cache.execute(DnsResolverConfig.NATIVE_RESOLVER, null, url.getProtocol(), url.getHost(), port, r);
		*/
	}

	public void ln(@Nullable String s)
	{
		logger.ln(s);
	}
}
