/* Copyright (C) 2009-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.rhino.runtime;

import org.glimmerblocker.proxy.rhino.callback.GlimmerGlobalObjectBase;
import org.jetbrains.annotations.NotNull;
import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

public interface ExecutorDelegate<CB extends GlimmerGlobalObjectBase>
{
	@NotNull
	CB create(@NotNull ScriptableObject scope,
	          @NotNull Scriptable defaultPrototype) throws Exception;


	void prepare(@NotNull CB callback, @NotNull Context ctx) throws Exception;


	@SuppressWarnings({"UnusedDeclaration"})
	void executionDone(@NotNull CB callback) throws Exception;
}
