#!/bin/sh

# http://clang.llvm.org/StaticAnalysis.html

# Put scan-build into your $PATH, if located elsewhere

CLANG=/usr/local/llvm-clang
PATH="$CLANG/bin:$PATH"

pushd ..
export SYMROOT=`pwd`/tmp/xcode
popd

XCODEBUILD=${XCODEBUILD:-xcodebuild}
XCODEBUILD="$XCODEBUILD -configuration Debug SYMROOT=$SYMROOT"


rm -rf /tmp/scan-build-*

# clean so we get a full rebuild and all files are analyzed (and not only the dirty ones)
$XCODEBUILD clean > /dev/null

time $CLANG/scan-build \
		 --view \
		 $XCODEBUILD \
				OTHER_CFLAGS="-DDEBUG=1 -DSTATIC_ANALYSIS=1" \
				OTHER_CPLUSPLUSFLAGS="-DDEBUG=1 -DSTATIC_ANALYSIS=1"

echo "#"
echo "# Cleans build."
echo "#"
# clean again, so we dont have leftover *.o files from llvm-clang mixing with gcc files.
$XCODEBUILD clean > /dev/null

echo "# All done."
